<?php

error_reporting(E_ALL);

//phpinfo();

//print_r( $_SERVER["argv"] );

$argv_1 = $argv_2 = '';

// dir check
if( $_SERVER["argv"][1] ) $argv_1 = $_SERVER["argv"][1] ;

if( !is_dir( $argv_1 ) ){
	echo "Is not Directory. \n" ;
	exit;
}

$dir = $argv_1 ;

if( $_SERVER["argv"][2] ) $argv_2 = $_SERVER["argv"][2] ;

$ini_file = "ppmaker_config.ini" ;

if( $argv_2 ) {
	//  ִ Ȯ.
	if( file_exists($argv_2) ) {
		$ini_file = $argv_2 ;
	}
}


list( $arrDir , $arrFile ) = getDirFiles($dir);

$ini_array = parse_ini_file( $ini_file , true);


//print_r($arrDir);
//print_r($arrFile);

$filelist = getPackageFileList( $arrFile , $dir , $ini_array['base_config']['installdir'] ) ;
// ini  array_var  ٸ  local_var ?


//  item ,  ԷѴ.
//  config   ó? package_config.ini  ⺻ Է, ?
// parse_ini_file .. package_config.ini
//  ܰ谡 1ܰθ óǴ  .

// ܰ.
// package - name , summary , description , maintainers , release 
// maintainers - maintainer
// maintainer - user , name , email , role
// release - version , date , license , state , notes , filelist
// filelist - file , dir ..



//print_r($ini_array);

$local_var_array = array( "filelist"=>$filelist );


$package_xml = getHeader();
$package_xml .= ppmaker_out( $ini_array , 'package' , $local_var_array , 1 ) ;

echo $package_xml ;


/*
[first_section]
one = 1
five = 5
animal = BIRD

[second_section]
path = /usr/local/bin
URL = "http://www.example.com/~username"


define('BIRD', 'Dodo bird');

// Parse without sections
$ini_array = parse_ini_file("sample.ini");
print_r($ini_array);

// Parse with sections
$ini_array = parse_ini_file("sample.ini", true);
print_r($ini_array);
*/

##################################################################

function ppmaker_out( $ini_array , $start_key , $local_var_array , $depth = 0 ) {

	$ppmaker_out = '';
	if( $start_key == 'package' ) $ppmaker_out = "<package version=\"1.0\">\n" ;

	foreach( $ini_array[$start_key] as $key => $val ) {
		// ini_array_sub , local_var Ȯ.
		if( $val == 'ini_array_sub' || $val == 'local_var' ) {
			if( $val == 'ini_array_sub' ) {
				 $ppmaker_out .= getPackageItem( $key , ppmaker_out( $ini_array , $key , $local_var_array , $depth + 1 ) , $depth + 1 , true );
			}
			if( $val == 'local_var' ) {
				 $ppmaker_out .= $local_var_array[$key] ;
			}
			
		}else{
			$ppmaker_out .= getPackageItem( $key , $val , $depth + 1 ) ;
		}

	}


	if( $start_key == 'package' ) $ppmaker_out .= "</package>\n" ;

	return $ppmaker_out ;

}

function getPackageFileList( $arrFiles , $base_dir , $base_install_dir , $base_key_dir = '' , $depth = 0 ) {

	if( !ereg("/$" , $base_dir ) ) {
		$base_dir = $base_dir . '/' ;
	}

	$depth_blank = getDepthBlank(2) ;
	$depth_blank2 = getDepthBlank(3) ;

	$package_filelist = '';

	if( $depth == 0 ) 	$package_filelist = $depth_blank . "<filelist>\n" ;

	foreach( $arrFiles as $key => $val ) {
		//  .
		//print_r( $arrFiles ) ;
		//echo "depth: " . $depth . " -- " . $key . "\n" ;

		if( !is_array($val) ) {
			$file_ext = getFileExt($key) ;
			// js , html , css  ϵ php  ó?
			// php|ext|src|test|doc|data|script ==>  ٸ 丮 ̵..
			// src Ǵ data , script ?
			// ׳ php  ؾ.
			if( $file_ext == 'php' || $file_ext == 'inc' ){
				$file_ext = 'php' ;
			}else if( $file_ext == 'js' || $file_ext == 'html' || $file_ext == 'css'  ){
				$file_ext = 'php' ;
			}else if( $file_ext == 'sh' ){
				$file_ext = 'script' ;
				$base_install_dir = '';
			}else{
				$file_ext = 'doc' ;
			}
			$filename = $key ;
			$check_md5 = md5_file($base_dir . $filename);
			$package_filelist .= $depth_blank2 . "<file role=\"$file_ext\" baseinstalldir=\"$base_install_dir\" md5sum=\"$check_md5\" name=\"" . $base_key_dir . $filename . "\"/>\n";
		}else{
			// $base_dir = $base_dir . $key . '/' ; // getPackageFileList  ѱ涧 ó.
			$package_filelist .= getPackageFileList( $val , $base_dir . $key . '/' , $base_install_dir , $base_key_dir . $key . '/' , $depth+1 ) ;
		}

	} // end foreach..

	if( $depth == 0 ) 	$package_filelist .= $depth_blank . "</filelist>\n" ;

	return $package_filelist ;
}


function getFileExt( $filename ){
	$file_ex = explode( "." , $filename ) ;

	$file_ex_count = count( $file_ex ) ;

	return strtolower( $file_ex[$file_ex_count-1] ) ;

}


function getDirFiles($dir) {
	$arrDir = array();
	$arrFile = array();

	if( !ereg("/$" , $dir ) ) {
		$dir = $dir . '/' ;
	}

	$d = dir( $dir );

	while(false !== ($e = $d->read())) {
		if( $e != '.' && $e != '..' ) {
			if( is_dir( $dir . $e ) ) {
//				echo $dir . $e . '/' . "\n" ;
				list( $arrDir[$e] , $arrFile[$e] ) = getDirFiles( $dir . $e . '/' ) ;
			}else{
//				echo $e . "\n" ;
				$arrFile[$e] = $e ;
			}
		}
	}
   $d->close();

	return array( $arrDir , $arrFile ) ;
}


##################################################################
// DTD  о  ó  ?

function getDepthBlank($depth) {
	$depth_blank = '';
	while( $depth ) {
		$depth_blank .= " " ;
		$depth-- ;
	}
	return $depth_blank ;
}

function getPackageItem( $item_name , $item_value , $depth = 0 , $newline = false ) {
	$depth_blank = getDepthBlank($depth) ;

	if( $newline == true ) {
		$package_item = $depth_blank . "<" . $item_name . ">\n" . $item_value . $depth_blank . "</" . $item_name . ">\n" ;
	}else{
		$package_item = $depth_blank . "<" . $item_name . ">" . $item_value . "</" . $item_name . ">\n" ;
	}

	return $package_item ;
}


function getHeader() {

return '<?xml version="1.0" encoding="euc-kr" ?>
<!DOCTYPE package SYSTEM "http://pear.php.net/dtd/package-1.0">
';

}


##################################################################

//echo $_GET ;

/*
$chkfilename = "package.xml";

$chkmd5 = md5($chkfilename);

$chkmd5return = md5_file($chkfilename);

echo $chkmd5 ."\n" ;
echo $chkmd5return ."\n" ;
*/

?>
